//  Xbox360 Input Machine  Test Program  by kako

#include <windows.h>
#include <stdio.h>
#include <conio.h>

#include "ipc_xfer_lib.h"
#include "XIMcore.h"

XIMXbox360Input xi;

int main()
{
	int ret;
	char buf[1024];
	int n,d1,d2,d3,d4,d5;
	int x0,y0,x1,y1;
	
	ret = open_mem_rd();
	if (ret == -1) {
		//printf("ret = %d\n",ret);
		printf("KINECT OpenNI side is not ready.\n",ret);
	}
	printf("\n");

	ret = XIMConnect();
	
	if (ret != XIMSTATUS_OK) {
		printf("XIM Connect error (%d)\n",ret); getch(); exit(1);
	}
	printf("XIM Connect OK\n");
	printf("\n");
	
	printf("XIM Send testing...\n");
	XIMSendXbox360Input(&xi);
	printf("XIM Send OK\n");
	printf("\n");
	
	printf("XIM Key Input started. (ESC key to quit.)\n");
	while (1) {
		unsigned char c;
		if (kbhit()) {
			c=getch();
			if (c==0x1B) { break; }
			if (c=='w') {
				xi.Up=TRUE;  XIMSendXbox360Input(&xi);
				xi.Up=FALSE; XIMSendXbox360Input(&xi);
			}
			if (c=='s') {
				xi.Down=TRUE;  XIMSendXbox360Input(&xi);
				xi.Down=FALSE; XIMSendXbox360Input(&xi);
			}
			if (c=='a') {
				xi.Left=TRUE;  XIMSendXbox360Input(&xi);
				xi.Left=FALSE; XIMSendXbox360Input(&xi);
			}
			if (c=='d') {
				xi.Right=TRUE;  XIMSendXbox360Input(&xi);
				xi.Right=FALSE; XIMSendXbox360Input(&xi);
			}
			if (c=='z') {
				xi.A=TRUE;  XIMSendXbox360Input(&xi);
				xi.A=FALSE; XIMSendXbox360Input(&xi);
			}
			if (c=='x') {
				xi.B=TRUE;  XIMSendXbox360Input(&xi);
				xi.B=FALSE; XIMSendXbox360Input(&xi);
			}
			if ((c==0x0D)||(c==' ')) {
				xi.Start=TRUE;  XIMSendXbox360Input(&xi);
				xi.Start=FALSE; XIMSendXbox360Input(&xi);
			}
		}
		
		read_mem(buf);
		if (strlen(buf)>1) {
			n=sscanf(buf,"%d,%d,%d,%d,%d",&d1,&d2,&d3,&d4,&d5);
			if ( (n==5)&&(d1==1000) ) {
				x0=d2; y0=d3;
				x1=d4; y1=d5;
				x0= (int)(  (float)x1 * 3.0  );
				y0= (int)(  (float)y1 * 3.0  );
				x1= (int)(  (float)x1 * 1.5  );
				y1= (int)(  (float)y1 * 1.5  );
				if (x0> 127) { x0=  127; } else if (x0<-127) { x0= -127; }
				if (y0> 127) { y0=  127; } else if (y0<-127) { y0= -127; }
				if (x1> 127) { x1=  127; } else if (x1<-127) { x1= -127; }
				if (y1> 127) { y1=  127; } else if (y1<-127) { y1= -127; }
				//printf("(%d,%d) , (%d,%d)\n",x0,y0,x1,y1);
				xi.LeftStickX  = x0; xi.LeftStickY  = y0;
				xi.RightStickX = x1; xi.RightStickY = y1;
				 XIMSendXbox360Input(&xi);
			}
		}
	}
	printf("Quit.\n");
	XIMDisconnect();
	close_mem_rd();
	
	return 0;
}
